# Generated by sila2.code_generator; sila2.__version__: 0.9.2
from __future__ import annotations

from typing import TYPE_CHECKING, Any, List

from sila2.server import MetadataDict

from ..generated.connectionconfigurationservice import (
    ConnectionConfigurationServiceBase,
    ConnectSiLAClient_Responses,
    DisableServerInitiatedConnectionMode_Responses,
    DisconnectSiLAClient_Responses,
    EnableServerInitiatedConnectionMode_Responses,
)

if TYPE_CHECKING:
    from ..server import Server


class ConnectionConfigurationServiceImpl(ConnectionConfigurationServiceBase):
    def __init__(self, parent_server: Server) -> None:
        super().__init__(parent_server=parent_server)

    def get_ServerInitiatedConnectionModeStatus(self, *, metadata: MetadataDict) -> bool:
        raise NotImplementedError  # TODO

    def get_ConfiguredSiLAClients(self, *, metadata: MetadataDict) -> List[Any]:
        raise NotImplementedError  # TODO

    def EnableServerInitiatedConnectionMode(
        self, *, metadata: MetadataDict
    ) -> EnableServerInitiatedConnectionMode_Responses:
        raise NotImplementedError  # TODO

    def DisableServerInitiatedConnectionMode(
        self, *, metadata: MetadataDict
    ) -> DisableServerInitiatedConnectionMode_Responses:
        raise NotImplementedError  # TODO

    def ConnectSiLAClient(
        self, ClientName: str, SiLAClientHost: str, SiLAClientPort: int, Persist: bool, *, metadata: MetadataDict
    ) -> ConnectSiLAClient_Responses:
        raise NotImplementedError  # TODO

    def DisconnectSiLAClient(
        self, ClientName: str, Remove: bool, *, metadata: MetadataDict
    ) -> DisconnectSiLAClient_Responses:
        raise NotImplementedError  # TODO
